/*
 * @Author: ysh
 * @Date: 2025-07-08 15:10:42
 * @LastEditors: 
 * @LastEditTime: 2025-07-09 11:37:02
 */
package com.ruoyi.web.llm.controller;

import com.ruoyi.web.llm.service.ILangChainMilvusService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import dev.langchain4j.model.embedding.EmbeddingModel;
import dev.langchain4j.model.embedding.onnx.bgesmallzhv15.BgeSmallZhV15EmbeddingModel;
import io.milvus.client.MilvusServiceClient;
import io.milvus.param.ConnectParam;
import org.noear.solon.ai.chat.message.AssistantMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;

import java.io.IOException;
import java.util.List;

/**
 * rag增强检索生成对话Controller
 * 
 * @author cmc
 * @date 2025-04-08
 */
@RestController
@RequestMapping("/llm/rag")
public class RagController extends BaseController
{
    @Autowired
    private ILangChainMilvusService langChainMilvusService;

    private static final EmbeddingModel embeddingModel = new BgeSmallZhV15EmbeddingModel();

    private static final MilvusServiceClient milvusClient = new MilvusServiceClient(
            ConnectParam.newBuilder()
                    .withHost("192.168.28.188")
                    .withPort(19530)
                    .build());

    /**
     * 增强检索生成回答
     */
    @GetMapping("/answer")
    public Flux<AssistantMessage> answer(String question, String collectionName) throws IOException {

        List<String> contexts = langChainMilvusService.retrieveFromMilvus(milvusClient, embeddingModel, collectionName, question, 1);
        return langChainMilvusService.generateAnswerWithRag(question, contexts, "http://192.168.28.188:8000/v1/chat/completions");
    }

}
