package com.ruoyi.web.llm.service;

import dev.langchain4j.model.embedding.EmbeddingModel;
import io.milvus.client.MilvusClient;
import io.milvus.grpc.MutationResult;
import io.milvus.param.R;
import org.noear.solon.ai.chat.message.AssistantMessage;
import org.springframework.web.multipart.MultipartFile;
import reactor.core.publisher.Flux;

import java.io.IOException;
import java.util.List;

public interface ILangChainMilvusService {

    /**
     * 导入知识库文件
     */
    public R<MutationResult> insertLangchainEmbeddingDocument(MilvusClient milvusClient, MultipartFile file, String collectionName, EmbeddingModel embeddingModel) throws IOException;

    /**
     * 从Milvus检索相关文档
     */
    public List<String> retrieveFromMilvus(MilvusClient milvusClient, EmbeddingModel embeddingModel, String collectionName, String query, int topK);

    /**
     * 调用LLM+RAG生成回答
     * @return
     */
    public Flux<AssistantMessage> generateAnswerWithRag(String question, List<String> contexts, String llmServiceUrl);

    /**
     * 调用LLM生成回答
     * @return
     */
    public Flux<AssistantMessage> generateAnswer(String question, String llmServiceUrl);
}
