/*
 * @Author: ysh
 * @Date: 2025-06-30 09:56:10
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2025-07-03 10:47:54
 */
import request from '@/utils/request'

// 查询知识库列表
export function listKnowledge(query) {
  return request({
    url: '/llm/knowledge/list',
    method: 'get',
    params: query
  })
}

// 新增知识库
export function addKnowledge(collectionName, description) {
  return request({
    url: '/llm/knowledge/create',
    method: 'post',
    params: { collectionName, description }
  })
}

// 修改知识库
export function updateKnowledge(collectionName, newCollectionName) {
  return request({
    url: '/llm/knowledge/modify',
    method: 'post',
    params: { collectionName, newCollectionName }
  })
}

// 删除知识库
export function delKnowledge(collectionName) {
  return request({
    url: '/llm/knowledge/remove',
    method: 'delete',
    params: { collectionName }
  })
}

// 插入知识库文件
export function insertKnowledgeFile(file, collectionName) {
  const formData = new FormData()
  formData.append('file', file)
  formData.append('collectionName', collectionName)
  return request({
    url: '/llm/knowledge/insertDocument',
    method: 'post',
    data: formData,
    headers: {
      'Content-Type': 'multipart/form-data'
    }
  })
}

// 查看知识库文件
export function listKnowledgeDocument(collectionName, fileType) {
  return request({
    url: '/llm/knowledge/listDocument',
    method: 'get',
    params: { collectionName, fileType }
  })
}

// 删除知识库文件
export function deleteKnowledgeFile(fileName,collectionName) {
  return request({
    url: '/llm/knowledge/removeDocument',
    method: 'delete',
    params: { fileName, collectionName }
  })
}
